Skip to main content

K Inverse Pairs Array

Problem Description​

For an integer array nums, an inverse pair is a pair of integers [i, j] where 0 <= i < j < nums.length and nums[i] > nums[j].

Given two integers n and k, return the number of different arrays consisting of numbers from 1 to n such that there are exactly k inverse pairs. Since the answer can be huge, return it modulo 109 + 7.

Examples​

Example 1:

Input: n = 3, k = 0
Output: 1
Explanation: Only the array [1,2,3] which consists of numbers from 1 to 3 has exactly 0 inverse pairs.

Example 2:

Input: n = 3, k = 1
Output: 2
Explanation: The array [1,3,2] and [2,1,3] have exactly 1 inverse pair.

Constraints​

  • 1 <= n <= 1000
  • 0 <= k <= 1000

Solution for K Inverse Pairs Array​

Approach​

dp[n][k] denotes the number of arrays that have k inverse pairs for array composed of 1 to n we can establish the recursive relationship between dp[n][k] and dp[n-1][i]:

if we put n as the last number then all the k inverse pair should come from the first n-1 numbers if we put n as the second last number then there's 1 inverse pair involves n so the rest k-1 comes from the first n-1 numbers ... if we put n as the first number then there's n-1 inverse pairs involve n so the rest k-(n-1) comes from the first n-1 numbers

dp[n][k] = dp[n-1][k]+dp[n-1][k-1]+dp[n-1][k-2]+...+dp[n-1][k+1-n+1]+dp[n-1][k-n+1]

It's possible that some where in the right hand side the second array index become negative, since we cannot generate negative inverse pairs we just treat them as 0, but still leave the item there as a place holder.

dp[n][k] = dp[n-1][k]+dp[n-1][k-1]+dp[n-1][k-2]+...+dp[n-1][k+1-n+1]+dp[n-1][k-n+1] dp[n][k+1] = dp[n-1][k+1]+dp[n-1][k]+dp[n-1][k-1]+dp[n-1][k-2]+...+dp[n-1][k+1-n+1]

so by deducting the first line from the second line, we have

dp[n][k+1] = dp[n][k]+dp[n-1][k+1]-dp[n-1][k+1-n]

Code in Different Languages​

Written by @Shreyash3087
int kInversePairs(int n, int k) {
vector<int> dp(k+1, 0);
int mod = 1e9+7;
for(int i=1; i<=n; i++){
vector<int> tmp(k+1, 0);
tmp[0] = 1;
for(int j =1; j<=k; j++){
long long val = (dp[j] + mod - ((j-i) >=0 ? dp[j-i] : 0))%mod;
tmp[j] = (tmp[j-1] + val)%mod;
}
dp = tmp;
}
return (dp[k] + mod - (k>0 ? dp[k-1] : 0))%mod;
}

Complexity Analysis​

Time Complexity: O(Nβˆ—k)O(N*k)​

Space Complexity: O(Nβˆ—k)O(N*k)​

References​